<?php

namespace Restaurant\Master;

use User;

class Master
{
    /**
     * $category object.
     */
    protected $category;    /**
     * $cuisine object.
     */
    protected $cuisine;    /**
     * $master object.
     */
    protected $master;

    /**
     * Constructor.
     */
    public function __construct(\Restaurant\Master\Interfaces\CategoryRepositoryInterface $category,        \Restaurant\Master\Interfaces\CuisineRepositoryInterface $cuisine,        \Restaurant\Master\Interfaces\MasterRepositoryInterface $master)
    {
        $this->category = $category;        $this->cuisine = $cuisine;        $this->master = $master;
    }

    /**
     * Returns count of master.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.category.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->category->pushCriteria(new \Litepie\Restaurant\Repositories\Criteria\CategoryUserCriteria());
        }

        $category = $this->category->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('master::' . $view, compact('category'))->render();
    }    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.cuisine.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->cuisine->pushCriteria(new \Litepie\Restaurant\Repositories\Criteria\CuisineUserCriteria());
        }

        $cuisine = $this->cuisine->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('master::' . $view, compact('cuisine'))->render();
    }    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.master.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->master->pushCriteria(new \Litepie\Restaurant\Repositories\Criteria\MasterUserCriteria());
        }

        $master = $this->master->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('master::' . $view, compact('master'))->render();
    }
}
